module Workarea
  module MagentoMigrator
    class CatalogProduct

      COLUMNS = [
        "custom_design_from", "custom_design_to", "news_from_date", "news_to_date", "special_from_date", "special_to_date", "am_giftcard_price_percent", "am_giftcard_prices", "am_open_amount_max", "am_open_amount_min", "cost", "group_price", "licensing_fee", "minimal_price", "msrp", "price", "special_price", "tier_price", "weight", "am_allow_message", "am_allow_open_amount", "am_giftcard_code_set", "am_giftcard_lifetime", "am_giftcard_price_type", "am_giftcard_type", "commercial_quote_materials", "featured", "form_materials", "is_recurring", "links_exist", "links_purchased_separately", "manufacturer", "material", "needs_editorial_approval", "new", "old_id", "orientation", "package_type", "price_type", "price_view", "scalable_pattern", "shipment_type", "sku_type", "status", "style", "tax_class_id", "visibility", "weight_type", "category_ids", "created_at", "has_options", "required_options", "sku", "updated_at", "am_giftcard_code_image", "colors", "custom_layout_update", "description", "meta_keyword", "recurring_profile", "search_tags", "searchindex_weight", "short_description", "am_email_template", "artist_name", "country_of_manufacture", "cs_sort_order", "custom_design", "feed_dimensions", "feed_product_image", "gallery", "gift_message_available", "height", "image", "image_label", "links_title", "media_gallery", "meta_description", "meta_title", "msrp_display_actual_price_type", "msrp_enabled", "name", "number_of_sales", "options_container", "package_depth", "package_height", "package_width", "page_layout", "rating", "rf123_id", "rf123_url", "sale_price", "samples_title", "small_image", "small_image_label", "small_price", "thumbnail", "thumbnail_label", "url_key", "url_path", "width"
      ]

      def read_csv_file
        # parsing the magento csv file
        file = "lib/data/product_catalog_from_magento.csv"
        csv = CSV.read(file)
        # get the column
        puts col =  csv[0].inspect
        # get the row
        puts row = csv[1].inspect
        puts convert_to_workarea_product(row)
      end

      def convert_to_workarea_product(row)  # defined a method to do the mapping job
        murals_product = []
        murals_product << row
        puts murals_product.inspect
        # murals_product.to_csv(file_name: 'workarea_product_data.csv')
        # Import the file to workarea
        Workarea::DataFile::Import.create(file_name: 'murals_product', file_type: 'csv')
      end

      class << self
        
        def table_name
          @@table_name ||= 'catalog_product'
        end

      end # class self declaration
    end # class end
  end
end
